import { ICypressConfiguration } from "@badeball/cypress-configuration";
interface IEnvironmentOverrides {
    stepDefinitions?: string | string[];
    messagesEnabled?: boolean;
    messagesOutput?: string;
    jsonEnabled?: boolean;
    jsonOutput?: string;
    htmlEnabled?: boolean;
    htmlOutput?: string;
    filterSpecs?: boolean;
    omitFiltered?: boolean;
}
export interface IUserConfiguration {
    readonly stepDefinitions?: string | string[];
    readonly messages?: {
        enabled: boolean;
        output?: string;
    };
    readonly json?: {
        enabled: boolean;
        output?: string;
    };
    readonly html?: {
        enabled: boolean;
        output?: string;
    };
    readonly filterSpecs?: boolean;
    readonly omitFiltered?: boolean;
}
export interface IPreprocessorConfiguration {
    readonly stepDefinitions: string | string[];
    readonly messages: {
        enabled: boolean;
        output: string;
    };
    readonly json: {
        enabled: boolean;
        output: string;
    };
    readonly html: {
        enabled: boolean;
        output: string;
    };
    readonly filterSpecs: boolean;
    readonly omitFiltered: boolean;
    readonly implicitIntegrationFolder: string;
}
export declare function combineIntoConfiguration(configuration: IUserConfiguration, overrides: IEnvironmentOverrides, cypress: ICypressConfiguration, implicitIntegrationFolder: string): IPreprocessorConfiguration;
export type ConfigurationFileResolver = (projectRoot: string) => unknown | Promise<unknown>;
export declare function resolve(cypressConfig: ICypressConfiguration, environment: Record<string, unknown>, implicitIntegrationFolder: string, configurationFileResolver?: ConfigurationFileResolver): Promise<IPreprocessorConfiguration>;
export {};
